#ifdef GL_ES 
precision mediump float; 
#endif 
varying MEDP vec2 uvVarying;

uniform sampler2D sampler;
uniform float t_r;
uniform float t_g;
uniform float t_b;
uniform float t_a;

uniform float t_bright;
uniform float t_offset;

void main()
{ 
	float off = t_offset;

	vec4 clr = texture2D ( sampler, uvVarying );
	vec4 out_clr = vec4(0, 0, 0, 0);

  	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y+off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y+off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x,uvVarying.y+off) );
	off += t_offset;

	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y+off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y+off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x,uvVarying.y+off) );
	off += t_offset;

	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y+off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y+off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x-off,uvVarying.y) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x+off,uvVarying.y) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x,uvVarying.y-off) );
	out_clr += texture2D ( sampler, vec2(uvVarying.x,uvVarying.y+off) );

	out_clr.a *= t_bright;
	out_clr.r = t_r*out_clr.a;
	out_clr.g = t_g*out_clr.a;
	out_clr.b = t_b*out_clr.a;

	float out_a = clr.a*t_a;
	float out_a_t = (1.0-clr.a)*t_a;

	out_clr = out_clr*vec4(out_a_t, out_a_t, out_a_t, out_a_t) + clr*vec4(out_a, out_a, out_a, out_a);

	gl_FragColor = out_clr;
}